<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\Util;

class RelatCustomEventoRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    static $incidencias;
    static $incidenciasConditions;
    /**
     * @return array
     */

    public function getRelatCustomEvento($parameters, $filters) {
        
    self::$incidencias = array (
     "1" => 'IDIRRFEVEFOLHA', 
     "2" => 'IDINSSEVEFOLHA', 
     "3" => 'IDFGTSEVEFOLHA', 
     "4" => 'IDIRRFEVERESC', 
     "5" => 'IDINSSEVERESC', 
     "6" => 'IDFGTSEVERESC', 
     "7" => 'IDIRRFEVERESC13', 
     "8" => 'IDINSSEVERESC13', 
     "9" => 'IDFGTSEVERESC13', 
     "10" => 'IDFGTSEVERESFER', 
     "11" => 'IDINSSEVERESFER', 
     "12" => 'IDFGTSEVERESFER', 
     "13" => 'IDIRRFEVEADIAN', 
     "14" => 'IDINSSEVEADIAN', 
     "15" => 'IDFGTSEVEADIAN', 
     "16" => 'IDIRRFEVEFERIAS', 
     "17" => 'IDINSSEVEFERIAS', 
     "18" => 'IDFGTSEVEFERIAS', 
     "19" => 'IDIRRFEVE13', 
     "20" => 'IDINSSEVE13', 
     "21" => 'IDFGTSEVE13', 
     "22" => 'IDEVEREMUN', 
     "23" => 'IDEVEADIANT', 
     "24" => 'IDEVEFERIAS', 
     "25" => 'IDEVE13', 
     "26" => 'IDEVEHREXTRA', 
     "27" => 'IDEVEADNOTUR', 
     "28" => 'IDEVEADINSA', 
     "29" => 'IDEVEADPERI', 
     "30" => 'IDEVEFALTAS', 
     "31" => 'IDEVEVALE', 
     "32" => 'IDEVECONTSIND', 
     "33" => 'IDEVESALFAMI', 
     "34" => 'IDEVESALMATER', 
     "35" => 'IDEVEAVISO', 
     "36" => 'IDEVEPENSAO', 
     "37" => 'IDEVESUBFERIAS', 
     "46" => 'IDEVESALMENS', 
     "56" => 'IDINSSEVEPRO', 
     "57" => 'IDEVEREFHREXTRSR', 
     "58" => 'IDEVEREFADNOTUR');
        
    Util::getValueInFilterDataSourceByName($filters, self::$incidencias, true);
    $conditions = Util::createQueryFiltered($filters);
 
    
    foreach ($parameters as $key => $param) {
        if(in_array ($key, self::$incidencias)){
            self::filterIncidencia($key,$param);
        }
    }
    $conditions .= self::$incidenciasConditions;
    
    if(array_key_exists('IDTIPOOCORREVEN', $parameters)) {
        $listTipoOcorrencia = array_map(function($tipoOcorrencia) {
            return $tipoOcorrencia;
        },
        $parameters['IDTIPOOCORREVEN']);
        $conditions .= " AND IDTIPOOCORREVEN IN ('" . implode('\',\'',$listTipoOcorrencia) . "') ";
    } else {
        $condTipoOcorrencia = "";
    }
    
    if(array_key_exists('IDTIPOEVENTO', $parameters)) {
        $listTipoEvento = array_map(function($tipoEvento) {
            return $tipoEvento;
        },
        $parameters['IDTIPOEVENTO']);
        $conditions .= " AND IDTIPOEVENTO IN ('" . implode('\',\'',$listTipoEvento) . "') ";
    } else {
        $condTipoEvento = "";
    }
      
    
    $query = $this->entityManager->getConnection()->prepare("
        SELECT * FROM 
            (SELECT
            EVM.DTINIVIGENCIA,
            EVM.DTFIMVIGENCIA,
            EVM.IDTIPOEVENTO,
            EVH.*,
            EVR.NMEVENTOH AS NMEVENTORESCIS,
            EVT.NMEVENTOH AS NMEVENTOTRANSF,
            EVE.NMEVENTOH AS NMEVENTOESTORNO,
            NR.NMNATURUBR,
            CTB.CDCONTCTBLDEB,
            CTB.CDHISTPADRDEB,
            CTB.CDCONTCTBLCRE,
            CTB.CDHISTPADRCRE,
            CTB.CDDESPADMFAT,
            D_ADM.DSDESPADMFAT,
            CC.NMCONTCTBL AS NMCONTCTBLCRE,
            CD.NMCONTCTBL AS NMCONTCTBLDEB,
            HC.DSHISTPADR AS DSHISTPADRCRE,
            HD.DSHISTPADR AS DSHISTPADRDEB,
            HR.DSHOMOLOGRUBRICA,
            (select ',' || LISTAGG(NRTIPOINCIDE, ',') WITHIN GROUP (ORDER BY NRTIPOINCIDE) || ','
                from
                    FPA_INCIDEVENTO 
                where
                    NREVENTOM = EVM.NREVENTOM 
                    AND (
                        NRORG=:NRORG 
                        OR NRORG=:NRORG_PADRAO
                    )) AS INCIDEEVENTO 
        FROM
            FPA_EVENTOM EVM 
        INNER JOIN FPA_EVENTOH EVH 
                ON(
                    EVH.NREVENTOM = EVM.NREVENTOM 
                    AND EVH.NRORG = EVM.NRORG 
                ) 
                AND EVH.DTMESCOMPETENC =(
                    SELECT  MAX(EVTH.DTMESCOMPETENC) 
                FROM
                    FPA_EVENTOH EVTH 
                WHERE
                    EVTH.NRORG = EVH.NRORG 
                    AND EVTH.NREVENTOM = EVH.NREVENTOM 
                    AND EVTH.DTMESCOMPETENC <= :DTMESCOMPETENC 
                ) 
        LEFT JOIN FPA_EVENTOH EVR 
                ON(
                    EVR.NREVENTORESCIS = EVM.NREVENTOM 
                    AND EVR.NRORG = EVM.NRORG 
                ) 
                AND EVR.DTMESCOMPETENC =(
                    SELECT  MAX(EVRH.DTMESCOMPETENC) 
                FROM
                    FPA_EVENTOH EVRH 
                WHERE
                    EVRH.NRORG = EVR.NRORG 
                    AND EVRH.NREVENTOM = EVR.NREVENTOM 
                    AND EVRH.DTMESCOMPETENC <= :DTMESCOMPETENC 
                ) 
        LEFT JOIN FPA_EVENTOH EVT 
                ON(
                    EVT.NREVENTOTRANSF = EVM.NREVENTOM 
                    AND EVT.NRORG = EVM.NRORG 
                ) 
                AND EVT.DTMESCOMPETENC =(
                    SELECT  MAX(EVTRH.DTMESCOMPETENC) 
                FROM
                    FPA_EVENTOH EVTRH 
                WHERE
                    EVTRH.NRORG = EVT.NRORG 
                    AND EVTRH.NREVENTOM = EVT.NREVENTOM 
                    AND EVTRH.DTMESCOMPETENC <= :DTMESCOMPETENC 
                ) 
        LEFT JOIN FPA_EVENTOH EVE 
                ON(
                    EVE.NREVENTOESTORNO = EVM.NREVENTOM 
                    AND EVE.NRORG = EVM.NRORG 
                ) 
                AND EVE.DTMESCOMPETENC =(
                    SELECT MAX(EVEH.DTMESCOMPETENC) 
                FROM
                    FPA_EVENTOH EVEH 
                WHERE
                    EVEH.NRORG = EVE.NRORG 
                    AND EVEH.NREVENTOM = EVE.NREVENTOM 
                    AND EVEH.DTMESCOMPETENC <= :DTMESCOMPETENC 
                ) 
        LEFT JOIN NATUREZARUBRICA NR 
                ON NR.NRNATURUBR = EVH.NRNATURUBR 
                AND(
                    NR.NRORG = EVH.NRORG 
                    OR NR.NRORG = :NRORG_PADRAO 
                ) 
        LEFT JOIN FPA_HOMOLOGRUBRICA HR 
                ON HR.CDHOMOLOGRUBRICA = EVH.NRHOMOLOGRUBRICA 
                AND(
                    HR.NRORG = EVH.NRORG 
                    OR HR.NRORG = :NRORG_PADRAO 
                ) 
        LEFT JOIN FPA_EVENTOCTBL CTB 
                ON(
                    CTB.NRORG = EVM.NRORG 
                    AND CTB.NREVENTOM = EVM.NREVENTOM 
                    AND CTB.NRESTRUTURAM IS NULL 
                ) 
        LEFT JOIN CONTCTBL CC 
                ON (
                    CC.CDCONTCTBL = CTB.CDCONTCTBLCRE 
                    AND CC.NRORG = CTB.NRORG 
                ) 
        LEFT JOIN CONTCTBL CD 
                ON (
                    CD.CDCONTCTBL = CTB.CDCONTCTBLDEB 
                    AND (
                        CD.NRORG = CTB.NRORG 
                        OR CD.NRORG = :NRORG_PADRAO 
                    ) 
                ) 
        LEFT JOIN HISTPADR HC 
                ON (
                    HC.CDHISTPADR = CTB.CDHISTPADRCRE 
                    AND (
                        HC.NRORG = CTB.NRORG 
                        OR HC.NRORG = :NRORG_PADRAO 
                    ) 
                ) 
        LEFT JOIN HISTPADR HD 
                ON (
                    HD.CDHISTPADR = CTB.CDHISTPADRDEB 
                    AND (
                        HD.NRORG = CTB.NRORG 
                        OR HD.NRORG = :NRORG_PADRAO 
                    ) 
                ) 
        LEFT JOIN DESPADMFATUR D_ADM 
                ON (
                    CTB.CDDESPADMFAT = D_ADM.CDDESPADMFAT 
                    AND CTB.NRORG = D_ADM.NRORG 
                ) 
        WHERE
                EVM.NRORG = :NRORG 
                OR EVM.NRORG = :NRORG_PADRAO
                )
        WHERE 1=1
        $conditions"
      );

    $query->execute(
        array(
          "DTMESCOMPETENC"  => $parameters['DTMESCOMPETENC'],
          "NRORG"           => $parameters['NRORG'],
          "NRORG_PADRAO"    => $parameters['NRORG_PADRAO'],
        )
      );
    return self::insertIncidencia($query->fetchAll());
    }
    
    public function insertIncidencia(array $rows){
        foreach($rows as $key => &$row){
            $incidencias = explode(",", $row['INCIDEEVENTO']);
            in_array("1",$incidencias)?$row['IDIRRFEVEFOLHA']="S":$row['IDIRRFEVEFOLHA']="N";
            in_array("2",$incidencias)?$row['IDINSSEVEFOLHA']="S":$row['IDINSSEVEFOLHA']="N";
            in_array("3",$incidencias)?$row['IDFGTSEVEFOLHA']="S":$row['IDFGTSEVEFOLHA']="N";
            in_array("4",$incidencias)?$row['IDIRRFEVERESC']="S":$row['IDIRRFEVERESC']="N";
            in_array("5",$incidencias)?$row['IDINSSEVERESC']="S":$row['IDINSSEVERESC']="N";
            in_array("6",$incidencias)?$row['IDFGTSEVERESC']="S":$row['IDFGTSEVERESC']="N";
            in_array("7",$incidencias)?$row['IDIRRFEVERESC13']="S":$row['IDIRRFEVERESC13']="N";
            in_array("8",$incidencias)?$row['IDINSSEVERESC13']="S":$row['IDINSSEVERESC13']="N";
            in_array("9",$incidencias)?$row['IDFGTSEVERESC13']="S":$row['IDFGTSEVERESC13']="N";
            in_array("10",$incidencias)?$row['IDFGTSEVERESFER']="S":$row['IDFGTSEVERESFER']="N";
            in_array("11",$incidencias)?$row['IDINSSEVERESFER']="S":$row['IDINSSEVERESFER']="N";
            in_array("12",$incidencias)?$row['IDFGTSEVERESFER']="S":$row['IDFGTSEVERESFER']="N";
            in_array("13",$incidencias)?$row['IDIRRFEVEADIAN']="S":$row['IDIRRFEVEADIAN']="N";
            in_array("14",$incidencias)?$row['IDINSSEVEADIAN']="S":$row['IDINSSEVEADIAN']="N";
            in_array("15",$incidencias)?$row['IDFGTSEVEADIAN']="S":$row['IDFGTSEVEADIAN']="N";
            in_array("16",$incidencias)?$row['IDIRRFEVEFERIAS']="S":$row['IDIRRFEVEFERIAS']="N";
            in_array("17",$incidencias)?$row['IDINSSEVEFERIAS']="S":$row['IDINSSEVEFERIAS']="N";
            in_array("18",$incidencias)?$row['IDFGTSEVEFERIAS']="S":$row['IDFGTSEVEFERIAS']="N";
            in_array("19",$incidencias)?$row['IDIRRFEVE13']="S":$row['IDIRRFEVE13']="N";
            in_array("20",$incidencias)?$row['IDINSSEVE13']="S":$row['IDINSSEVE13']="N";
            in_array("21",$incidencias)?$row['IDFGTSEVE13']="S":$row['IDFGTSEVE13']="N";
            in_array("22",$incidencias)?$row['IDEVEREMUN']="S":$row['IDEVEREMUN']="N";
            in_array("23",$incidencias)?$row['IDEVEADIANT']="S":$row['IDEVEADIANT']="N";
            in_array("24",$incidencias)?$row['IDEVEFERIAS']="S":$row['IDEVEFERIAS']="N";
            in_array("25",$incidencias)?$row['IDEVE13']="S":$row['IDEVE13']="N";
            in_array("26",$incidencias)?$row['IDEVEHREXTRA']="S":$row['IDEVEHREXTRA']="N";
            in_array("27",$incidencias)?$row['IDEVEADNOTUR']="S":$row['IDEVEADNOTUR']="N";
            in_array("28",$incidencias)?$row['IDEVEADINSA']="S":$row['IDEVEADINSA']="N";
            in_array("29",$incidencias)?$row['IDEVEADPERI']="S":$row['IDEVEADPERI']="N";
            in_array("30",$incidencias)?$row['IDEVEFALTAS']="S":$row['IDEVEFALTAS']="N";
            in_array("31",$incidencias)?$row['IDEVEVALE']="S":$row['IDEVEVALE']="N";
            in_array("32",$incidencias)?$row['IDEVECONTSIND']="S":$row['IDEVECONTSIND']="N";
            in_array("33",$incidencias)?$row['IDEVESALFAMI']="S":$row['IDEVESALFAMI']="N";
            in_array("34",$incidencias)?$row['IDEVESALMATER']="S":$row['IDEVESALMATER']="N";
            in_array("35",$incidencias)?$row['IDEVEAVISO']="S":$row['IDEVEAVISO']="N";
            in_array("36",$incidencias)?$row['IDEVEPENSAO']="S":$row['IDEVEPENSAO']="N";
            in_array("37",$incidencias)?$row['IDEVESUBFERIAS']="S":$row['IDEVESUBFERIAS']="N";
            in_array("46",$incidencias)?$row['IDEVESALMENS']="S":$row['IDEVESALMENS']="N";
            in_array("56",$incidencias)?$row['IDINSSEVEPRO']="S":$row['IDINSSEVEPRO']="N";
            in_array("57",$incidencias)?$row['IDEVEREFHREXTRSR']="S":$row['IDEVEREFHREXTRSR']="N";
            in_array("58",$incidencias)?$row['IDEVEREFADNOTUR']="S":$row['IDEVEREFADNOTUR']="N";
            unset($row['INCIDEEVENTO']);
        }
        return $rows;
    }
    
    public function filterIncidencia($incidencia, $param){
        foreach (self::$incidencias as $chave => $value) {
            if ($value == $incidencia){
                if($param=='S') 
                    self::$incidenciasConditions .= " AND INCIDEEVENTO LIKE '%,$chave,%' ";
                if($param=='N') 
                    self::$incidenciasConditions .= " AND INCIDEEVENTO NOT LIKE '%,$chave,%' ";
                
            }
        }
    }
    
    public function getParametrizacaoEsocial($parameters, $conditions){
        $query = $this->entityManager->getConnection()->prepare("SELECT * FROM(
                 SELECT DISTINCT
                        RUB.NREVENTOM,
                        FPA_EVENTOH.NMEVENTOH,
                        FPA_EVENTOH.DTMESCOMPETENC,
                        RUB.NRORG,
                        FPA_EVENTOH.NRNATURUBR,
                        SUBSTR(NATUREZARUBRICA.CDESOCIAL, 0, 1) AS NRAGRUPRUBRICA,
                        NATUREZARUBRICA.NMNATURUBR,
                        NATUREZARUBRICA.CDESOCIAL,
                        RUB.NRRUBRICA,
                        RUB.NRTIPOMOVIMENT,
                        TM.NMTIPOMOVIMENT,
                        RUB.NRTIPORUBRICA,
                        RUB.DTINCLUSAO,
                        RUB.CDOPERINCLUSAO,
                        RUB.NRORGINCLUSAO,
                        RUB.DTULTATU,
                        RUB.CDOPERULTATU,
                        RUB.NRORGULTATU,
                        NVL(RUB.CDINCIDECP,'00') NRINCIDECP,
                        DECODE( RUB.NREVENTOM, 3080, '79', NVL(RUB.CDINCIDEIRRF,'79') ) NRINCIDEIRRF,
                        NVL(RUB.CDINCIDEFGTS,'00') NRINCIDEFGTS
                        FROM
                            ESO_RUBRICA RUB
                        
                        JOIN FPA_EVENTOH ON FPA_EVENTOH.NREVENTOM = RUB.NREVENTOM
                                        AND FPA_EVENTOH.DTMESCOMPETENC = (
                                            SELECT MAX(EH.DTMESCOMPETENC)
                                            FROM FPA_EVENTOH EH
                                            WHERE EH.NREVENTOM = FPA_EVENTOH.NREVENTOM
                                                AND EH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                        )
                        
                            JOIN FPA_TIPOMOVIMENT TM ON TM.NRTIPOMOVIMENT = RUB.NRTIPOMOVIMENT
                            JOIN NATUREZARUBRICA ON  NATUREZARUBRICA.NRNATURUBR = FPA_EVENTOH.NRNATURUBR
                        WHERE
                            (RUB.NRORG = :P_NRORG OR RUB.NRORG = :P_NRORG_PADRAO)
                            AND (RUB.NREVENTOM = :P_NREVENTOM OR :P_NREVENTOM IS NULL)
                            AND (
                                    RUB.NRORG = :P_NRORG OR
                                    NOT EXISTS (
                                        SELECT 1
                                        FROM ESO_RUBRICA RUB2
                                        WHERE RUB2.NRORG = :P_NRORG
                                            AND RUB2.NRTIPOMOVIMENT = RUB.NRTIPOMOVIMENT
                                            AND RUB2.NREVENTOM = RUB.NREVENTOM
                                    )
                                )
                            ORDER BY RUB.NREVENTOM,RUB.NRTIPOMOVIMENT)
            WHERE 1 = 1
            ".$conditions);
            
        $queryParameters = array('P_NRORG'          => $parameters['P_NRORG'],
                                 'P_NRORG_PADRAO'   => $parameters['P_NRORG_PADRAO'],
                                 'P_DTMESCOMPETENC' => $parameters['P_DTMESCOMPETENC'],
                                 'P_NREVENTOM'      => array_key_exists('P_NREVENTOM', $parameters) ? $parameters['P_NREVENTOM'] : null);
        
        $query->execute($queryParameters);
        
        return $query->fetchAll();
    }
    
    public function getParametrizacaoNrtipoincideEsocial($parameters, $conditions){
        
        if(array_key_exists('NREVENTOM_LIST', $parameters)) {
            $nreventom = implode(",", $parameters['NREVENTOM_LIST']);
            $condNrEventom = "AND NREVENTOM IN ($nreventom)";
        } else {
            $condNrEventom = "";
        }
        if(array_key_exists('NRTIPOMOVIMENT_LIST', $parameters)) {
            $nrtomoviment = implode(",", $parameters['NRTIPOMOVIMENT_LIST']);
            $condNrTpMoviment = "AND  NRTIPOMOVIMENT IN ($nrtomoviment)";
        } else {
            $condNrTpMoviment = "";
        }
        $query = $this->entityManager->getConnection()->prepare("SELECT * FROM(
                 SELECT DISTINCT  FPA_EVENTOM.NREVENTOM,
                                   FPA_EVENTOH.NMEVENTOH,
                                   FPA_EVENTOH.DTMESCOMPETENC,
                                   FPA_EVENTOH.NRORG,
                                   NVL(CP.CDESOCIAL,'00') NRINCIDECP,
                                   NVL(IRRF.CDESOCIAL,'00') NRINCIDEIRRF,
                                   NVL(SIND.CDESOCIAL,'00') NRINCIDESIND,
                                   NVL(FGTS.CDESOCIAL,'00') NRINCIDEFGTS,
                                   TM.NRTIPOMOVIMENT,
                                   TM.NMTIPOMOVIMENT,
                                   DECODE(CP.NRTIPOINCIDE,   NULL, NULL, CP.NRTIPOINCIDE   || ', ') ||
                                   DECODE(IRRF.NRTIPOINCIDE, NULL, NULL, IRRF.NRTIPOINCIDE || ', ') ||
                                   DECODE(FGTS.NRTIPOINCIDE, NULL, NULL, FGTS.NRTIPOINCIDE || ', ') ||
                                   DECODE(SIND.NRTIPOINCIDE, NULL, NULL, SIND.NRTIPOINCIDE ) NRSOMABASE
                    FROM FPA_EVENTOM 
                    JOIN FPA_EVENTOH ON FPA_EVENTOH.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                    AND FPA_EVENTOH.NRORG = FPA_EVENTOM.NRORG
                                    AND FPA_EVENTOH.DTMESCOMPETENC = (SELECT MAX(EH.DTMESCOMPETENC)
                                                                        FROM FPA_EVENTOH EH
                                                                       WHERE EH.NREVENTOM = FPA_EVENTOH.NREVENTOM
                                                                         AND EH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                    JOIN FPA_TIPOMOVIMENT TM ON TM.NRTIPOMOVIMENT IN (1,2,4,10,19,22)
                    JOIN NATUREZARUBRICA ON  NATUREZARUBRICA.NRNATURUBR = FPA_EVENTOH.NRNATURUBR
               /*CONTRIBUICAO PREVIDENCIARIA NOVO*/
                 LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL,
                                   LISTAGG(IE.NRTIPOINCIDE, ', ') WITHIN GROUP (ORDER BY IE.NRTIPOINCIDE) NRTIPOINCIDE
                              FROM FPA_INCIDEVENTO IE
                              JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                              JOIN INCIDENCIACP INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                                   AND (INC.NRORG = :P_NRORG OR INC.NRORG = 0)
                             WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                   AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                              FROM FPA_GRPITEM 
                                                             WHERE NRGRPINCIDE = 46) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                          GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT ) CP ON CP.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                                                         AND INSTR(','||CP.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
               /*IRRF NOVO*/
               LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL,
                                   LISTAGG(IE.NRTIPOINCIDE, ', ') WITHIN GROUP (ORDER BY IE.NRTIPOINCIDE) NRTIPOINCIDE
                            FROM FPA_INCIDEVENTO IE
                            JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                            JOIN INCIDENCIAIRRF INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                                   AND (INC.NRORG = :P_NRORG OR INC.NRORG = 0)
                           WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                  AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                             FROM FPA_GRPITEM 
                                                            WHERE NRGRPINCIDE = 47) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                        GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT) IRRF ON IRRF.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                                                        AND INSTR(','||IRRF.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
               /*FGTS NOVO*/
               LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL,
                                   LISTAGG(IE.NRTIPOINCIDE, ', ') WITHIN GROUP (ORDER BY IE.NRTIPOINCIDE) NRTIPOINCIDE
                            FROM FPA_INCIDEVENTO IE
                            JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                            JOIN INCIDENCIAFGTS INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                                   AND (INC.NRORG = :P_NRORG OR INC.NRORG = 0)
                           WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                             AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                             FROM FPA_GRPITEM 
                                                            WHERE NRGRPINCIDE = 48) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                        GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT) FGTS ON FGTS.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                                                                                 AND INSTR(','||FGTS.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
               /*CONTRIBUICAO SINDICAL NOVO*/
                 LEFT JOIN (SELECT IE.NREVENTOM, REPLACE(TI.DSNRTIPOMOVIMENT, ' ', '') AS DSNRTIPOMOVIMENT, MAX(INC.CDESOCIAL) AS CDESOCIAL,
                                   LISTAGG(IE.NRTIPOINCIDE, ', ') WITHIN GROUP (ORDER BY IE.NRTIPOINCIDE) NRTIPOINCIDE
                              FROM FPA_INCIDEVENTO IE
                              JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IE.NRTIPOINCIDE
                              JOIN INCIDENCIASIND INC ON INSTR(','||INC.DSNRTIPOINCIDE||',',','||TI.NRTIPOINCIDE||',') > 0
                                                   AND (INC.NRORG = :P_NRORG OR INC.NRORG = 0)
                             WHERE (IE.NRORG = :P_NRORG OR IE.NRORG = 0)
                                    AND (IE.NRTIPOINCIDE IN (SELECT NRTIPOINCIDE 
                                                             FROM FPA_GRPITEM 
                                                            WHERE NRGRPINCIDE = 49) OR TI.DSNRTIPOMOVIMENT IS NOT NULL)
                          GROUP BY IE.NREVENTOM, TI.DSNRTIPOMOVIMENT) SIND ON SIND.NREVENTOM = FPA_EVENTOM.NREVENTOM
                                                                          AND INSTR(','||SIND.DSNRTIPOMOVIMENT||',',','||TM.NRTIPOMOVIMENT||',') > 0
                   WHERE (FPA_EVENTOM.NRORG = :P_NRORG OR FPA_EVENTOM.NRORG = :P_NRORG_PADRAO)
                         AND (FPA_EVENTOM.NREVENTOM = :P_NREVENTOM OR :P_NREVENTOM IS NULL) 
                         
                         
                ORDER BY FPA_EVENTOM.NREVENTOM, TM.NRTIPOMOVIMENT
                
                
                )
            WHERE 1 = 1
            ".
            $conditions.
            $condNrEventom.
            $condNrTpMoviment);
        $queryParameters = array('P_NRORG'          => $parameters['P_NRORG'],
                                 'P_NRORG_PADRAO'   => $parameters['P_NRORG_PADRAO'],
                                 'P_DTMESCOMPETENC' => $parameters['P_DTMESCOMPETENC'],
                                 'P_NREVENTOM'      => array_key_exists('P_NREVENTOM', $parameters) ? $parameters['P_NREVENTOM'] : null);
        
        $query->execute($queryParameters);
        
        return $query->fetchAll();
    }


}

