<?php

namespace HCM\Geral\Entity;

use HCM\Util\Repositories;
use HCM\Util\TkEntity;
use HCM\Util\MsgCalculo;

class GpeparamoperEntity
{
    const ADMINISTRADOR = 'ADMINISTRADOR';
    const COMUM = 'COMUM';    
    const IDTPDTCOMPETE_OPERADOR = 'OPERADOR';
    const IDTPDTCOMPETE_ORGANIZACAO = 'ORGANIZACAO';
    const IDTPDTCOMPETE_GERAL = 'GERAL';
    const IDTPDTCOMPETE_SERVIDOR = 'SERVIDOR';
    const IDAMBIENTESAL_REAL = 'REAL';
    const IDAMBIENTESAL_CENARIO = 'CENARIO';
    const IDDEBUG_NAO = 'N';
    const IDDEBUG_SIM = 'S';

    private $_parametro;
    private $_nrOrgOperador;

    public function retornaParametrosOperador($nrOrg, $cdOperador){
        $this->_parametro = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMOPER)->findOneBy(array('nrorgtrab' => $nrOrg, 'cdoperador' => $cdOperador));
        
        if (is_object($this->_parametro) === true) {
            return true;
        } else {
            return false;
        }
    }

    public function retornaMesCompetenciaOperador() {
        if (is_object($this->_parametro) === true) {
            return $this->_parametro->getDtmescompetenc();
        }

    }

    public function retornaNrOrgTrabalho() {
        if (is_object($this->_parametro) === true) {
            $nrOrgTrab = $this->_parametro->getNrorgtrab();
            if ($nrOrgTrab === null) {
                return null;
            } else {
                return (int)$this->_parametro->getNrorgtrab();
            }
        }
    }

    public function retornaNrEstruturaTrabalho($nrOrg, $cdOperador) {
        if (is_object($this->_parametro) === true) {
           if (is_object($this->_parametro) === true) {
               return $this->_parametro->getNrestruttrab();
           }
        }   
    }

    public function retornaIdDebug() {
        if (is_object($this->_parametro) === true) {
            if ($this->_parametro->getIddebug() === GpeparamoperEntity::IDDEBUG_SIM) {
                return true;
            } else {
                return false;
            }
        }
    }

    public function retornaAmbienteSalarioOperador() {
        if (is_object($this->_parametro) === true) {
            return $this->_parametro->getIdambientesal();
        }
    }

    public function retornaTipoModalidadeSalario() {
        if (is_object($this->_parametro) === true) {
            return $this->_parametro->getNrtpmodalidsal();
        }
    }

    public function retornaTipoModalidadeCalculo(){
        if (is_object($this->_parametro) === true) {
            return (int)$this->_parametro->getNrtpmodalidcal();
        }
    }

    public function retornaNrOcorrenciaCalculo(){
        if (is_object($this->_parametro) === true) {
            return (int)$this->_parametro->getNrocorrecal();
        }
    }

    public function retornaTipoOperador($nrOrgOperador, $nrOrgPadrao){
        if ($nrOrgOperador === $nrOrgPadrao) {
            return self::ADMINISTRADOR;
        } else {
            return self::COMUM;
        }
    }
}