<?php
namespace HCM\Util;

use Zeedhi\Framework\Session\Session;
use HCM\Util\DateUtil as Geral_DateUtil;

class FPA {
    /**
     * @var Session
     */
    protected static $session;
    const PROC_CALCULO = 'CALCULO';
    const PROC_CALCULO_PARCIAL = 'PARCIAL';
    const PROC_SIMULACAO = 'SIMULACAO';
    const PROC_RETROCESSO = 'RETROCESSO';
    const PROC_COMPETENCIA_MENSAL = 'COMPETENCIA_MENSAL';
    const PROC_COMPETENCIA_13 = 'COMPETENCIA_13';
    const PROC_CADGOZOFERIAS = 'CADGOZOFERIAS';
    const PROC_APOLO_GRAVAR = 'CALCULO_APOLO_GRAVAR';
    const PROC_APOLO_GRAVAR_PARCIAL = 'CALCULO_APOLO_GRAVAR_PARCIAL';
    const PROC_CANCELAMENTO = 'CANCELAMENTO';
    const PROC_RECALCPATRONAL = 'RECALCPATRONAL';
    
    private static $opergrupop;
    
    public function __construct(Session $session)
    {
        self::$session = $session;
    }

    public static function set($param, $value) {
        self::$session->set($param, $value);
    }
    
    public static function setSession($session){
        self::$session = $session;
    }

    public static function getCdoperador() {
        $session = new Session();
        return $session->get('cdoperador');
    }

    public static function getNrorgPadrao() {
        $session = new Session();
        return $session->get('nrorgpadrao');
    }

    public static function getNrorg() {
        $session = new Session();
        return $session->get('nrorg');
    }

    public static function getNrorgTrabalho() {
        $session  = new Session();
        return $session->get('nrorgtrab');
    }

    public static function getTipoEstruturaLegalOrg() {
        $session  = new Session();
        return $session->get('nrtipoestrutlegal');
    }

    public static function getTipoEstruturaGerencialOrg() {
        $session  = new Session();
        return $session->get('nrtipoestrutgeren');
    }
    
    public static function getTipoEstruturaTomadorOrg() {
        $session  = new Session();
        $value = $session->get('nrtipoestrutomador');
        if(!$value){
            $value = 7;
        }
        return $value;
    }

    public static function getIdtpcompetencia() {
        return self::$session->get('idtpcompetencia');
    }

    public static function getIdambientesal() {
        return self::$session->get('idambientesal');
    }

    public static function getDtCompetencia() {
        $session  = new Session();
        return $session->get('dtmescompetenc');
    }

    public static function getEstruturaTrabalho() {
        $session  = new Session();
        return $session->get('nrestruttrab');
    }

    public static function getOcorrenciaCalculo() {
        $session  = new Session();
        return $session->get('nrocorrecal');
    }

    public static function getNrModalidadeCalculo() {
        $session  = new Session();
        return $session->get('nrtpmodalidcal');
    }

    public static function getNrModalidadeSalario() {
        $session  = new Session();
        return $session->get('nrtpmodalidsal');
    }

    public static function getUltimoDiaMes() {
        return Geral_DateUtil::getUltimoDiaDoMes(Geral_DateUtil::getDataDeString(self::getDtCompetencia()))->format(Geral_DateUtil::FORMATO_BRASILEIRO);
    }

    public static function getPrimeiroDiaDoMes() {
        return Geral_DateUtil::getPrimeiroDiaDoMes(Geral_DateUtil::getDataDeString(self::getDtCompetencia()))->format(Geral_DateUtil::FORMATO_BRASILEIRO);
    }

    public static function getDtmescomptencDiaCorrente() {
        return Geral_DateUtil::getPrimeiroDiaDoMes(Geral_DateUtil::getDataAtual())->format(Geral_DateUtil::FORMATO_BRASILEIRO);
    }
    
    public static function getDataAtual() {
        return Geral_DateUtil::getDataAtual()->format(Geral_DateUtil::FORMATO_BRASILEIRO);
    }
    
    public static function getTempDirectory() {
        $session  = new Session();
        $diretorio = $session->get('tempDirectory').DIRECTORY_SEPARATOR.self::getNrorgTrabalho();
        
        if(!file_exists($diretorio)){
            mkdir($diretorio);
        }
        
        return $session->get('tempDirectory').DIRECTORY_SEPARATOR.self::getNrorgTrabalho();
    }
    
    public static function getGpeParametrosOperador() {
        return \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMOPER)
            ->findOneBy(array("cdoperador" => self::getCdoperador(), "nrorg" => self::getNrorgTrabalho()));
    }
    
    public static function getGpeParametrosOrganizacao(){
        return \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMORG)
            ->findOneBy(array("nrorg" => self::getNrorgTrabalho()));
    }
    
    public static function getRestConfidencial(){
        foreach(self::getOpergrupop() as $grupo){
            if($grupo->getCdgrupoper()=='00'){
                return 'N';
            }
        }
        return 'S';
    }
    
    public static function getOpergrupop() {
        return self::$opergrupop = \Geral\Entities\Opergrupop::findByNrorgAndCdoperador(self::getNrorgTrabalho(), self::getCdoperador());
    }
    
    public static function getParamOper() {
        return \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMOPER)
            ->findOneBy(array("cdoperador" => self::getCdoperador(), "nrorg" => self::getNrorg()));
    }
    
    public static function getNrestrutlegalOper() {
        $gpe_paramOper = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMOPER)
            ->findOneBy(array("cdoperador" => self::getCdoperador(), "nrorg" => self::getNrorg()));
            
        return $gpe_paramOper->getNrestrutlegal();
    }
    
    public static function getNrestrutgerenOper() {
        $gpe_paramOper = \Setforms2\Shared\Registry::getEntityManager()->getRepository(Repositories::GPE_PARAMOPER)
            ->findOneBy(array("cdoperador" => self::getCdoperador(), "nrorg" => self::getNrorg()));
            
        return $gpe_paramOper->getNrestrutgeren();
    }
    
    public static function determinaNrCalculoFolha($tipoMovimento) {
        $mesCompetencia = self::getDtCompetencia();
        $nrOrgTrabalho = self::getNrorgTrabalho();
        $nrTpModalidadeCalc = self::getNrModalidadeCalculo();
        $nrOcorrenciaCalc = self::getOcorrenciaCalculo();
        $cdOperador = self::getCdoperador();

        $dtocorrencia = Geral_DateUtil::getDataDeString($mesCompetencia, Geral_DateUtil::FORMATO_BRASILEIRO, true);
        $calculoFolha = \Folha\Entities\FpaCalculofolha::retornaCalculoFolha($nrOrgTrabalho, $tipoMovimento, $dtocorrencia, $nrTpModalidadeCalc, $nrOcorrenciaCalc, $cdOperador);
        $calcFolha = current($calculoFolha);

        if(is_object($calcFolha)){
            return $calcFolha->getNrcalculofolha();
        }
        else{
            throw new \Exception('algum parâmetro do operador faltando.<br /> NRORG:'.$nrOrgTrabalho.'<BR />Tipo Movimento:'.$tipoMovimento.'<br />Mês comp.:'.$mesCompetencia.'<br />Tipo modalidade calc:'.$nrTpModalidadeCalc.'<br />Num. Ocorrêcia:'.$nrOcorrenciaCalc);
        }
    }
    
    public static function converteHoraDecimal($hora){

        $aux = floor($hora);

        if ($aux == $hora){
            return $hora;
        } else {
            $minuto = $hora - $aux;
            $decimal = $minuto * 100.0 / 60.0;
            $aux += $decimal;

            return $aux;
        }
    }
    
    public static function converteDecimalHoraMinuto($hora){

        $aux = floor($hora);

        if ($aux == $hora){
            return $hora;
        } else {
            $decimal = $hora - $aux;
            $minuto = ($decimal * 60.0)/100.0;
            $aux += $minuto;

            return $aux;
        }
    }
    
    public static function download($nmArquivo) {
        //@todo do
        $directoryTemp = self::getTempDirectory().'/';
        $filepath = $directoryTemp.$nmArquivo;
        if($filepath !== null && file_exists($filepath)){
            $extensao = explode('.', $filepath);
            header("Content-Type: ".$extensao[1]); // informa o tipo do arquivo ao navegador
            header("Content-Length: ".filesize($filepath)); // informa o tamanho do arquivo ao navegador
            header("Content-Disposition: attachment; filename=".(substr(basename($filepath),0))); // informa ao navegador que é tipo anexo e faz abrir a janela de download, tambem informa o nome do arquivo
            readfile($filepath); // lê o arquivo
            unlink($filepath);
            die;
        }
    }
    
    public static function escreveArquivo($nmArquivo, $conteudo, $array = false, $limpaArquivo = false) {
        
        $directoryTemp = self::getTempDirectory().'/';
        if($array){
            $conteudo = self::convertArrayString($conteudo);
        }
        if (!file_exists($directoryTemp.$nmArquivo)) {
            file_put_contents($directoryTemp.$nmArquivo, $conteudo);
        }else{
            if ($limpaArquivo) {
                file_put_contents($directoryTemp.$nmArquivo, "");
            }
            file_put_contents($directoryTemp.$nmArquivo, $conteudo, FILE_APPEND);
        }
        
    }
    
    public static function convertArrayString($dados){
        $string = null;
        if(is_array($dados)){
            foreach($dados as $value)
            $string .= (string)$value.PHP_EOL;
        }        
        else{
            $string = (string)$dados.PHP_EOL;
        }
        return $string;    
    }
    
    public static function getParamsApolo(){
        
        //PRODUÇÃO
        $params = array(
            "URL" => 'mobile-tools.teknisa.com', 
            "PORT" => '6113', 
            "USER" => 'admin', 
            "PASSWORD" => 'apolloadmin', 
            "BROKE" => 'broker'
        );
        
        //USADO NO LOCAL --- DESCOMENTAR PARA TESTAR
        // $params = array(
        //     "URL" => '192.168.122.65', 
        //     "PORT" => '6132', 
        //     "USER" => 'admin', 
        //     "PASSWORD" => 'apolloadmin', 
        //     "BROKE" => 'broker'
        // );
        
        return $params;
    }
} 